<?php
add_action('wp_ajax_cooked_ingredient_list', 'cooked_ingredient_list');
add_action('wp_ajax_nopriv_cooked_ingredient_list', 'cooked_ingredient_list');
function cooked_ingredient_list()
{
    global $wpdb;
    $search = like_escape($_REQUEST['q']);

    $query = 'SELECT ID,post_title FROM ' . $wpdb->posts . '
        WHERE post_title LIKE \'%' . $search . '%\'
        AND post_type = \'ingredient\'
        ORDER BY post_title ASC';
    foreach ($wpdb->get_results($query) as $row) {
        $post_title = $row->post_title;
        $id = $row->ID;
        $meta = get_post_meta($id, 'TEST', TRUE);
       // echo $post_title . ' (' . $meta . ')' . "\n";
        echo $post_title . "\n";
    }
    exit();
}



add_action('wp_ajax_cooked_add_recipe_ingredient', 'cooked_add_recipe_ingredient');
add_action('wp_ajax_nopriv_cooked_add_recipe_ingredient', 'cooked_add_recipe_ingredient');
function cooked_add_recipe_ingredient()
{
    global $wpdb;
    if(
        empty($_REQUEST['recipe_id']) ||
        !is_numeric($_REQUEST['recipe_id']) ||
        (
            empty($_REQUEST['ingredient_id']) && (
                empty($_REQUEST['ingredient']) ||
                !is_array($_REQUEST['ingredient']) ||
                !array_key_exists("post_title", $_REQUEST['ingredient'])
            )
        )
    )
    {
        echo '0';
        exit();
    }
    
    $recipe_id = intval($_REQUEST['recipe_id']);
    if( empty($_REQUEST['ingredient_id']) )
    {
        $post = array(
            'ID'             => NULL,
            'post_name'      => sanitize_title($_REQUEST['ingredient']['post_title']),
            'post_status'    => 'draft',
            'post_title'     => $_REQUEST['ingredient']['post_title'],
            'post_type'      => 'ingredient',
        );
        $ingredient_id = wp_insert_post( $post );     
    }
    else
    {
        $ingredient_id = intval($_REQUEST['ingredient_id']);
    }
    $quantity = !empty($_REQUEST['quantity']) ? $_REQUEST['quantity'] : '';


    $wpdb->insert( 
        COOKED_DB_TABLE, 
        array( 
            'recipe_id'     => $recipe_id, 
            'ingredient_id' => $ingredient_id,
            'quantity'      => $quantity
        ), 
        array( 
            '%d', 
            '%d',
            '%s'
        ) 
    );
    $data = array(
        'quantity'   => $quantity,
        'ingredient' => get_post($ingredient_id)
    );
    echo json_encode($data);
    exit();
}


add_action('wp_ajax_cooked_update_recipe_ingredient', 'cooked_update_recipe_ingredient');
add_action('wp_ajax_nopriv_cooked_update_recipe_ingredient', 'cooked_update_recipe_ingredient');
function cooked_update_recipe_ingredient()
{
    global $wpdb;
    if( empty($_REQUEST['recipe_id']) || !is_numeric($_REQUEST['recipe_id']) || empty($_REQUEST['ingredient_id']) || !is_numeric($_REQUEST['ingredient_id']) )
    {
        echo '0';
        exit();
    }



    $recipe_id = intval($_REQUEST['recipe_id']);
    $ingredient_id = intval($_REQUEST['ingredient_id']);
    $quantity = $_REQUEST['quantity'];

    $data = array(
        'success' => $wpdb->update( 
            COOKED_DB_TABLE, 
            array( 
                'quantity' => $quantity
            ), 
            array( 
                'recipe_id'     => $recipe_id,
                'ingredient_id' => $ingredient_id
            ), 
            array( 
                '%s'
            ), 
            array(
                '%d',
                '%d'
            ) 
        )
    );
    echo json_encode($data);
    exit();
}

add_action('wp_ajax_cooked_remove_recipe_ingredient', 'cooked_remove_recipe_ingredient');
add_action('wp_ajax_nopriv_cooked_remove_recipe_ingredient', 'cooked_remove_recipe_ingredient');
function cooked_remove_recipe_ingredient()
{
    global $wpdb;
    if( empty($_REQUEST['recipe_id']) || !is_numeric($_REQUEST['recipe_id']) || empty($_REQUEST['ingredient_id']) || !is_numeric($_REQUEST['ingredient_id']) )
    {
        echo '0';
        exit();
    }

    $recipe_id = intval($_REQUEST['recipe_id']);
    $ingredient_id = intval($_REQUEST['ingredient_id']);

    $data = array(
        'success' => $wpdb->delete(
            COOKED_DB_TABLE,
            array(
                'recipe_id'     => $recipe_id, 
                'ingredient_id' => $ingredient_id
            ),
            array(
                '%d',
                '%d'
            )
        )
    );
    echo json_encode($data);
    exit();
}











