<?php
class Cooked_Custom_Post_Types {
	public function __construct()
	{
		add_action('init', array(&$this,'posttype_recipe'), 0);
		add_action('init', array(&$this,'posttype_ingredient'), 0);

		add_action('init', array(&$this,'taxonomy_difficulty'), 0);
		add_action('init', array(&$this,'taxonomy_meal'), 0);
		add_action('init', array(&$this,'taxonomy_cuisine'), 0);
	}
	public function posttype_recipe()
	{
		$recipe = array(
			'label'               => __( 'Recipe', 'cooked' ),
			'description'         => __( 'Recipe information pages', 'cooked' ),
			'labels'              => array(
				'name'                => _x( 'Recipes', 'Post Type General Name', 'cooked' ),
				'singular_name'       => _x( 'Recipe', 'Post Type Singular Name', 'cooked' ),
				'menu_name'           => __( 'Recipes', 'cooked' ),
				'parent_item_colon'   => __( 'Parent Recipe:', 'cooked' ),
				'all_items'           => __( 'All Recipes', 'cooked' ),
				'view_item'           => __( 'View Recipe', 'cooked' ),
				'add_new_item'        => __( 'Add New Recipe', 'cooked' ),
				'add_new'             => __( 'New Recipe', 'cooked' ),
				'edit_item'           => __( 'Edit Recipe', 'cooked' ),
				'update_item'         => __( 'Update Recipe', 'cooked' ),
				'search_items'        => __( 'Search recipes', 'cooked' ),
				'not_found'           => __( 'No recipes found', 'cooked' ),
				'not_found_in_trash'  => __( 'No recipes found in Trash', 'cooked' ),
			),
			'supports'            => array( 'title', 'editor', 'author', 'thumbnail', 'excerpt', 'trackbacks', 'comments', 'revisions', 'post-formats' ),
			'taxonomies'          => array( 'post_tag', 'cuisine', 'meal', 'difficulty', 'category' ),
			'hierarchical'        => true,
			'public'              => true,
			'show_ui'             => true,
			'show_in_menu'        => true,
			'show_in_nav_menus'   => true,
			'show_in_admin_bar'   => true,
			'menu_position'       => 29,
			'menu_icon'           => '',
			'can_export'          => true,
			'has_archive'         => true,
			'exclude_from_search' => false,
			'publicly_queryable'  => true,
			'rewrite'             => array(
				'slug'                => 'recipes',
				'with_front'          => false,
				'pages'               => true,
				'feeds'               => true,
			),
			'capability_type'     => 'page',
		);
		if(!post_type_exists( 'recipe' ))
			register_post_type( 'recipe', $recipe );
	}
	public function posttype_ingredient()
	{
		$ingredient = array(
			'label'               => __( 'Ingredient', 'cooked' ),
			'description'         => __( 'Ingredient information pages', 'cooked' ),
			'labels'              => array(
				'name'                => _x( 'Ingredients', 'Post Type General Name', 'cooked' ),
				'singular_name'       => _x( 'Ingredient', 'Post Type Singular Name', 'cooked' ),
				'menu_name'           => __( 'Ingredients', 'cooked' ),
				'parent_item_colon'   => __( 'Parent Ingredient:', 'cooked' ),
				'all_items'           => __( 'All Ingredients', 'cooked' ),
				'view_item'           => __( 'View Ingredient', 'cooked' ),
				'add_new_item'        => __( 'Add New Ingredient', 'cooked' ),
				'add_new'             => __( 'New Ingredient', 'cooked' ),
				'edit_item'           => __( 'Edit Ingredient', 'cooked' ),
				'update_item'         => __( 'Update Ingredient', 'cooked' ),
				'search_items'        => __( 'Search ingredients', 'cooked' ),
				'not_found'           => __( 'No ingredients found', 'cooked' ),
				'not_found_in_trash'  => __( 'No ingredients found in Trash', 'cooked' ),
			),
			'supports'            => array( 'title', 'editor', 'thumbnail', 'excerpt', 'custom-fields', 'revisions', 'page-attributes', 'post-formats' ),
			'taxonomies'          => array( 'cuisine', 'post_tag', 'category' ),
			'hierarchical'        => true,
			'public'              => true,
			'show_ui'             => true,
			'show_in_menu'        => true,
			'show_in_nav_menus'   => true,
			'show_in_admin_bar'   => true,
			'menu_position'       => 30,
			'menu_icon'           => '',
			'can_export'          => true,
			'has_archive'         => true,
			'exclude_from_search' => false,
			'publicly_queryable'  => true,
			'rewrite'             => array(
				'slug'                => 'ingredients',
				'with_front'          => false,
				'pages'               => true,
				'feeds'               => true,
			),
			'capability_type'     => 'page',
		);
		if(!post_type_exists( 'ingredient' ))
			register_post_type( 'ingredient', $ingredient );
	}
	public function taxonomy_difficulty()
	{
		$difficulty = array(
			'labels'                     => array(
				'name'                       => _x( "Difficulty Levels", 'Taxonomy General Name', 'cooked' ),
				'singular_name'              => _x( "Difficulty Level", 'Taxonomy Singular Name', 'cooked' ),
				'menu_name'                  => __( "Difficulty Level", 'cooked' ),
				'all_items'                  => __( "All Difficulty Levels", 'cooked' ),
				'parent_item'                => __( "Parent Difficulty Level", 'cooked' ),
				'parent_item_colon'          => __( "Parent Difficulty Level:", 'cooked' ),
				'new_item_name'              => __( "New Difficulty Level Name", 'cooked' ),
				'add_new_item'               => __( "Add New Difficulty Level", 'cooked' ),
				'edit_item'                  => __( "Edit Difficulty Level", 'cooked' ),
				'update_item'                => __( "Update Difficulty Level", 'cooked' ),
				'separate_items_with_commas' => __( "Separate difficulty levels with commas", 'cooked' ),
				'search_items'               => __( "Search difficulty levels", 'cooked' ),
				'add_or_remove_items'        => __( "Add or remove difficulty levels", 'cooked' ),
				'choose_from_most_used'      => __( "Choose from the most used difficulty levels", 'cooked' ),
			),
			'hierarchical'               => false,
			'public'                     => true,
			'show_ui'                    => true,
			'show_admin_column'          => true,
			'show_in_nav_menus'          => true,
			'show_tagcloud'              => true,
			'query_var'                  => 'difficulty',
			'rewrite'                    => array(
				'slug'                       => 'difficulty',
				'with_front'                 => true,
			)
		);
		if(!taxonomy_exists( 'difficulty' ))
			register_taxonomy( 'difficulty', 'recipe', $difficulty );
	}
	public function taxonomy_meal()
	{
		$meal = array(
			'labels'                     => array(
				'name'                       => _x( "Meals", 'Taxonomy General Name', 'cooked' ),
				'singular_name'              => _x( "Meal", 'Taxonomy Singular Name', 'cooked' ),
				'menu_name'                  => __( "Meal", 'cooked' ),
				'all_items'                  => __( "All Meals", 'cooked' ),
				'parent_item'                => __( "Parent Meal", 'cooked' ),
				'parent_item_colon'          => __( "Parent Meal:", 'cooked' ),
				'new_item_name'              => __( "New Meal Name", 'cooked' ),
				'add_new_item'               => __( "Add New Meal", 'cooked' ),
				'edit_item'                  => __( "Edit Meal", 'cooked' ),
				'update_item'                => __( "Update Meal", 'cooked' ),
				'separate_items_with_commas' => __( "Separate meals with commas", 'cooked' ),
				'search_items'               => __( "Search meals", 'cooked' ),
				'add_or_remove_items'        => __( "Add or remove meals", 'cooked' ),
				'choose_from_most_used'      => __( "Choose from the most used meals", 'cooked' ),
			),
			'hierarchical'               => false,
			'public'                     => true,
			'show_ui'                    => true,
			'show_admin_column'          => true,
			'show_in_nav_menus'          => true,
			'show_tagcloud'              => true,
			'query_var'                  => 'meal',
			'rewrite'                    => array(
				'slug'                       => 'meal',
				'with_front'                 => true,
			)
		);		
		if(!taxonomy_exists( 'meal' ))
			register_taxonomy( 'meal', 'recipe', $meal );
	}
	public function taxonomy_cuisine()
	{
		$cuisine = array(
			'labels'                     => array(
				'name'                       => _x( "Cuisines", 'Taxonomy General Name', 'cooked' ),
				'singular_name'              => _x( "Cuisine", 'Taxonomy Singular Name', 'cooked' ),
				'menu_name'                  => __( "Cuisine", 'cooked' ),
				'all_items'                  => __( "All Cuisines", 'cooked' ),
				'parent_item'                => __( "Parent Cuisine", 'cooked' ),
				'parent_item_colon'          => __( "Parent Cuisine:", 'cooked' ),
				'new_item_name'              => __( "New Cuisine Name", 'cooked' ),
				'add_new_item'               => __( "Add New Cuisine", 'cooked' ),
				'edit_item'                  => __( "Edit Cuisine", 'cooked' ),
				'update_item'                => __( "Update Cuisine", 'cooked' ),
				'separate_items_with_commas' => __( "Separate cuisines with commas", 'cooked' ),
				'search_items'               => __( "Search cuisines", 'cooked' ),
				'add_or_remove_items'        => __( "Add or remove cuisines", 'cooked' ),
				'choose_from_most_used'      => __( "Choose from the most used cuisines", 'cooked' ),
			),
			'hierarchical'               => true,
			'public'                     => true,
			'show_ui'                    => true,
			'show_admin_column'          => true,
			'show_in_nav_menus'          => true,
			'show_tagcloud'              => true,
			'query_var'                  => 'cuisine',
			'rewrite'                    => array(
				'slug'                       => 'cuisine',
				'with_front'                 => true,
			)
		);
		if(!taxonomy_exists( 'cuisine' ))
			register_taxonomy( 'cuisine', array('recipe', 'ingredient'), $cuisine );
	}
}
$Cooked_Custom_Post_Types = new Cooked_Custom_Post_Types;