<?php
class Cooked_Init {
	public $plugin_pages = array(
		'edit-tags.php?taxonomy=difficulty-level&post_type=recipe',
		'edit-tags.php?taxonomy=meal&post_type=recipe',
		'edit-tags.php?taxonomy=cuisine&post_type=recipe',
	);
	public function __construct()
	{
		register_activation_hook( COOKED, array(&$this, '__install') );
		add_action( 'plugins_loaded', array(&$this, 'update_db_check') );

		//register_activation_hook( COOKED, array(&$this, '__install_data') );
		if(is_admin())
		{
			//add_action( 'admin_menu', array(&$this,'custom_menu_page'));
			add_action('admin_enqueue_scripts', array(&$this,'admin_scripts_init'));
			add_action('admin_init', array(&$this,'admin_styles_init'));
			//add_action('admin_init', array(&$this,'styles'));
		}
	}
	public function is_plugin_page()
	{
		$server_uri = "http://{$_SERVER['HTTP_HOST']}{$_SERVER['REQUEST_URI']}";
		//for example I added just one of page to check - lenslider_index as in lenslider_wp_pointer_content function
		foreach ($this->plugin_pages as $allowURI)
		{
			if(stristr($server_uri, $allowURI)) return true;
		}
		if ( ( isset($_GET['post_type']) && $_GET['post_type'] == 'recipe' ) || ( isset($post_type) && $post_type == 'recipe' ) || ( isset($_GET['post']) && get_post_type($_GET['post']) == 'recipe' ) ) {
		    return true;
		}

		return false;
	}
	public function __install()
	{
		$sql = "CREATE TABLE ".COOKED_DB_TABLE." (
			id mediumint(9) NOT NULL AUTO_INCREMENT,
			recipe_id mediumint(9) NOT NULL,
			ingredient_id mediumint(9) NOT NULL,
			quantity varchar(255) NOT NULL DEFAULT '',
			note varchar(255) NOT NULL DEFAULT '',
			base varchar(255) NOT NULL DEFAULT '',
			measure varchar(255) NOT NULL DEFAULT '',
			UNIQUE KEY id (id)
		);";
		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );
		update_site_option( COOKED_PREFIX . "db_version", COOKED_DB_VERSION );
	}
	public function update_db_check()
	{
	    if ( get_site_option( COOKED_PREFIX . "db_version" ) != COOKED_DB_VERSION )
	    {
	        $this->__install();
	    }
	}
	public function __install_data()
	{
	   global $wpdb;
	   $welcome_name = "Mr. WordPress";
	   $welcome_text = "Congratulations, you just completed the installation!";

	   $rows_affected = $wpdb->insert( $table_name, array( 'time' => current_time('mysql'), 'name' => $welcome_name, 'text' => $welcome_text ) );
	}


	public function custom_menu_page()
	{
		//add_menu_page( COOKED_SLUG, "Menu Title", "edit_posts", COOKED_SLUG, array(&$this,"menu_function"), "", 31 );
	}
	public function admin_scripts_init()
	{
	   if($this->is_plugin_page())
	   {
	   		global $wp_version;
		  //double check for WordPress version and function exists
			if(function_exists('wp_enqueue_media') && version_compare($wp_version, '3.5', '>='))
			{
				//call for new media manager
				wp_enqueue_media();
			}
			//old WP < 3.5
			else
			{
				wp_enqueue_script('media-upload');
				wp_enqueue_script('thickbox');
				wp_enqueue_style('thickbox');
			}
			//our script
			wp_register_script('media_uploader', COOKED_URL . '/js/media.uploader.js');
			wp_register_script('cooked_admin', COOKED_URL . '/js/admin.js');
			wp_enqueue_script('media_uploader');
			wp_enqueue_script('cooked_admin');
	   }
	}
	public function admin_styles_init()
	{
	   if($this->is_plugin_page())
	   {
			wp_enqueue_style('media');
			wp_register_style('cooked_admin', COOKED_URL . '/css/admin.css');
			wp_enqueue_style('cooked_admin');
	   }
	}
	public function styles()
	{
		wp_enqueue_style('cooked_styles', COOKED_URL . '/css/cooked.css');	
	}
}
$Cooked_Init = new Cooked_Init;