<?php
class Cooked_Templates {
	public function __construct()
	{
		add_filter( 'template_include', array(&$this, 'include_template_function'), 1 );
	}
	public function include_template_function( $template_path )
	{
		$post_type = get_post_type();
		if ( in_array($post_type, array('recipe','ingredient')) )
		{
			if ( is_single() )
			{
				$template_type = 'single';
			}
			elseif( is_archive() )
			{
				$template_type = 'archive';
			}

			if ( $theme_file = locate_template( array( "{$template_type}-{$post_type}.php" ) ) )
			{
				$template_path = $theme_file;
			}
			else
			{
				if (file_exists(TEMPLATEPATH."/{$template_type}.php"))
				{
				   $template_path = get_single_template();
				}
				else
				{
				    $template_path = COOKED_DIR ."/templates/{$template_type}-{$post_type}.php";
				}
			}
		}
		return $template_path;
	}
}
$Cooked_Templates = new Cooked_Templates;